# extconf for ruby-password
#
# $Id: extconf.rb,v 1.7 2002/06/19 00:29:52 ianmacd Exp $

require 'mkmf'

CRACK_DICT = 'cracklib_dict.pwd'

dict = []
search_dirs = %w(/usr/local /usr /opt)

# find the crack dictionary
print "checking for #{CRACK_DICT}... "
search_dirs.each do |d|
  dict = Dir.glob(File.join(d, "lib", CRACK_DICT))

  # create a header file pointing to the crack dictionary
  unless dict.empty?
    puts "yes"
    path = dict[0].sub(/\.pwd/, '')
    hfile = File.new("rbcrack.h", 'w')
    hfile.printf("#define CRACK_DICT \"%s\"\n", path)
    hfile.close
    break
  end

end

if dict.empty?
  puts "no\nCouldn't find #{CRACK_DICT} on this system"
  exit 1
end

have_library('crack', 'FascistCheck')
create_makefile('crack')

File.open('Makefile', 'a') do |f|
  f.print <<EOF

extra-clean:	distclean
		-rm -f rbcrack.h $(docfiles)

docfiles	= doc/password.html doc/password.3

docs:		$(docfiles)

doc/password.html:	lib/password.rb
		rd2 lib/password.rb > doc/password.html

doc/password.3:		lib/password.rb
		rd2 -rrd/rd2man-lib.rb lib/password.rb > doc/password.3
EOF
end
